package cz.upol.jj1.lab05;

// Vycty/enumy jsou ve sve podstate tridy s fixnimi instancemi danymi kodem.
// Tj. nelze mit jinou instanci, nez ty vytvorene zde.
// Enumy nemohou dedit (z logiky veci) a nelze z nich dedit (s malou vyjimkou nize).
// Mohou ale implementovat rozhrani.
public enum Weekday implements Bragger {
    //nejprve vycet prvku - vytvarime konstruktorem (viz nize)
    MONDAY(1),
    //mala vyjimka: instance mohou byt (anonymni) typy dedici z naseho enumu
    JAVADAY(2){
        //cimz muzeme naprikald zmenit cast chovani
        @Override
        public boolean isBest() {
            return true;
        }
    },
    WEDNESDAY(3),
    THURSDAY(4),
    FRIDAY(5),
    SATURDAY(6),
    SUNDAY(7);  //jsou to konstanty, dle konvencí piseme velkym

    private final int czechWeekIndex;  //klasicke atributy

    public int number; //pokud nejsou final nebo zapouzdrene, mohou byt meneny! (ukazka v mainu)

    //konstruktor (privatni, funguje jen pro konstatny vyse, kdekoli jinde jej nepusti kompilator... proc?)
    Weekday(int czechWeekIndex){
        this.czechWeekIndex = czechWeekIndex;
    }
    //public/protected konstruktor kompilator ani nepusti

    //klasicky getter
    public int getCzechWeekIndex() {
        return czechWeekIndex;
    }

    //nejaka dalsi metoda (tato navic implementuje pozadovoany interface)
    @Override
    public boolean isBest(){
        return false;
    }

    //staticky obsah je taky ok
    public static void tryMe(){
        //Weekday weekday = new Weekday(3); // ... nepujde
        System.out.println("Hi!");
    }

}
